#!/bin/bash
#Scan for viruses in /home
NICE="$(which nice)"
IONICE="$(which ionice)"
CONTROL="/var/.clamdscan.control"
LOG="/var/log/virus_report_edc.log"
DATE="$(date +%F)"
#
# Es comprova que no s'hagi deshabilitat clamav-daemon
#
if [ -n "$(deb-systemd-invoke is-enabled clamav-daemon |grep -i disabled)" ]; then
		exit 0
fi
#
# Es comprova que clamav-daemon estigui actiu
#
if [ -n "$(deb-systemd-invoke is-active clamav-daemon |grep -i inactive)" ]; then
		exit 0
fi
#
# S'espera que clamab-daemon hagi creat el socket
#
while [ ! -S /run/clamav/clamd.ctl ];
do
	sleep 5s
done
echo "################################" >> $LOG 
echo "###### Starting clamdscan ######" >> $LOG
echo "################################" >> $LOG

date >> $LOG

for FOLDER in /home; do

if [ -f $CONTROL ] ; then
	$NICE -n 19 $IONICE -c2 -n7 find $FOLDER -type f -cnewer $CONTROL  -not -path '*/\.*' -type f \( ! -iname ".*" \) -print0 | xargs -0 -r clamdscan --multiscan --fdpass --infected --log=$LOG --move=/tmp --quiet
	touch $CONTROL
else
	$NICE -n 19 $IONICE -c2 -n7 find $FOLDER -not -path '*/\.*' -type f \( ! -iname ".*" \) -print0 | xargs -0 -r clamdscan --multiscan --fdpass --infected --log=$LOG --move=/tmp --quiet
	touch $CONTROL
fi
done

date >> $LOG
echo "################################" >> $LOG
echo "###### Finished clamdscan ######" >> $LOG
echo "################################" >> $LOG
echo " " >> $LOG
FILE_SIZE=$(du -m $LOG | cut -f1)
if [ "$FILE_SIZE" -ge 100 ]; then
	$NICE -n 19 $IONICE -c2 -n7 gzip -c $LOG > $LOG."$DATE".gz
	rm $LOG
	LIMIT_LOG=5
	LIMIT_COUNT="$(find $LOG.*.gz  2>/dev/null |sort|uniq|wc -l)"
	if [ "$LIMIT_COUNT" -gt $LIMIT_LOG ]; then
		let 'DELTA_LIMIT = LIMIT_COUNT-LIMIT_LOG'
		for i in $(find $LOG.*.gz |sort|uniq|head -n $DELTA_LIMIT); do
		   rm "$i"
		done
	fi
fi
systemctl stop clamav-daemon > /dev/null 2>&1
